Attribute VB_Name = "MMain"
Option Explicit


Private Const cmSpace As String = " "

''-------------------------------------------------------------------------
'' MAin : Fonction principale
''
'' HISTORIQUE DES REVISIONS :
'' Cr le : 12/03/2000
'' Auteur  : C.Nunes
''
'' <jj/mm/aaaa> - <Nom de l auteur> - <Description de la rvision>
''-------------------------------------------------------------------------
Private Sub Main()
    Dim colParam As Collection   ''Paramtres de la ligne de commande
    Dim oAInstDB As TCAinstDB
    Dim oMain As Object
    
    If Len(Command) = 0 Then
        '' Aucun argument -> Mode graphique
        Set oMain = New frmMain
        Load oMain
        oMain.Show vbModal
        Unload oMain
        
    Else
        '' Des arguments sont spcifis -> Mode ligne de commande
        Set colParam = GetArgs(Command())
        
        If colParam Is Nothing Then
            GoTo usage_handler
        End If
        
        If colParam.Count <> 7 Then
            GoTo usage_handler
        End If
        
        Set oAInstDB = New TCAinstDB

        With oAInstDB
            oAInstDB.m_lError = colParam.Item(cmErrArg)
            oAInstDB.m_sLogFile = colParam.Item(cmLogArg)
            oAInstDB.LoadStoredProcs colParam.Item(cmPathArg), colParam.Item(cmServArg), _
                                     colParam.Item(cmBaseArg), colParam.Item(cmUserArg), _
                                     colParam.Item(cmPassArg)
            Set oAInstDB = Nothing
        End With
    End If
    
    '' Quitte l'application
    End

usage_handler:
    MsgBox App.EXEName + " [-E <error> -U <user>  -P <password>  -S <server>  -B <base>  -D ou -F <path>]" & Chr(13) & _
           "               -E : 0 = stop l'excution  la moindre erreur / 1 = poursuit l'excution" & Chr(13) & _
           "               -U : compte SQL" & Chr(13) & _
           "               -P : mot de passe pour le compte SQL" & Chr(13) & _
           "               -S : serveur SQL" & Chr(13) & _
           "               -B : base de donnes SQL" & Chr(13) & _
           "               -D : chemin du rpertoire contenant les procdures  charger" & Chr(13) & _
           "               -F : fichier des procdures  charger" & Chr(13) & _
           "               -L : fichier de log", vbInformation + vbOKOnly, App.EXEName & " - Usage"

End Sub

''-------------------------------------------------------------------------
'' GetArgs : Sauvegarde des paramtres  partir de la ligne de commande
''
'' HISTORIQUE DES REVISIONS :
'' Cr le : 29/3/99
'' Auteur  : Fabien Agnesina
''
'' <jj/mm/aaaa> - <Nom de l auteur> - <Description de la rvision>
''-------------------------------------------------------------------------
'' sCommandLine : Ligne de commande en entre
''-------------------------------------------------------------------------
Private Function GetArgs(sCommandLine As String) As Collection
    Dim nPos As Integer
    Dim sRemaining As String, sIndex As String
    Dim colArg As Collection
    
On Error GoTo Error_Handler:

    '' Init
    nPos = 1
    sRemaining = LTrim(sCommandLine)
    Set colArg = New Collection
    
    
    '' Process each word
    Do While nPos > 0
        nPos = InStr(1, sRemaining, cmSpace, vbTextCompare)
        
        If nPos > 0 Then
            Select Case StrConv(Left(sRemaining, nPos - 1), vbUpperCase)
                Case cmErrOpt
                    sIndex = cmErrArg
                Case cmUserOpt
                    sIndex = cmUserArg
                Case cmPassOpt
                    sIndex = cmPassArg
                Case cmBaseOpt
                    sIndex = cmBaseArg
                Case cmServOpt
                    sIndex = cmServArg
                Case cmPathDOpt
                    sIndex = cmPathArg
                    g_sTypeSelect = cmSelectRep
                Case cmPathFOpt
                    sIndex = cmPathArg
                    g_sTypeSelect = cmSelectFichierTexte
                Case cmLogOpt
                    sIndex = cmLogArg
                Case cmHelpOpt
                    Set colArg = Nothing
                    Exit Function
                Case Else
                    Set colArg = Nothing
                    Exit Do
            End Select
            
            '' Recupere la valeur du parametre
            sRemaining = Trim(Right(sRemaining, Len(sRemaining) - nPos))
            nPos = InStr(1, sRemaining, cmSpace, vbTextCompare)
            
            If nPos = 0 Then
                If sRemaining <> vbNullString Then
                    colArg.Add sRemaining, sIndex
                Else
                    Set colArg = Nothing
                    Exit Do
                End If
            Else
                colArg.Add Left(sRemaining, nPos - 1), sIndex
                sRemaining = Trim(Right(sRemaining, Len(sRemaining) - nPos))
            End If
        Else
            Set colArg = Nothing
            Exit Do
        End If
    Loop
    
    Set GetArgs = colArg
    Exit Function

Error_Handler:
    If Err.Number = 457 Then
        Resume Next         '' Un argument a ete passe plusieurs fois
    End If
    MsgBox Err.Description
End Function

